/* preferences-dialog.c generated by valac 0.56.17, the Vala compiler
 * generated from preferences-dialog.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2024 Johan Gay
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <adwaita.h>
#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_PREFERENCES_DIALOG (sudoku_preferences_dialog_get_type ())
#define SUDOKU_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_PREFERENCES_DIALOG, SudokuPreferencesDialog))
#define SUDOKU_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_PREFERENCES_DIALOG, SudokuPreferencesDialogClass))
#define IS_SUDOKU_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_PREFERENCES_DIALOG))
#define IS_SUDOKU_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_PREFERENCES_DIALOG))
#define SUDOKU_PREFERENCES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_PREFERENCES_DIALOG, SudokuPreferencesDialogClass))

typedef struct _SudokuPreferencesDialog SudokuPreferencesDialog;
typedef struct _SudokuPreferencesDialogClass SudokuPreferencesDialogClass;
typedef struct _SudokuPreferencesDialogPrivate SudokuPreferencesDialogPrivate;

#define TYPE_SUDOKU_WINDOW (sudoku_window_get_type ())
#define SUDOKU_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_WINDOW, SudokuWindow))
#define SUDOKU_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_WINDOW, SudokuWindowClass))
#define IS_SUDOKU_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_WINDOW))
#define IS_SUDOKU_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_WINDOW))
#define SUDOKU_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_WINDOW, SudokuWindowClass))

typedef struct _SudokuWindow SudokuWindow;
typedef struct _SudokuWindowClass SudokuWindowClass;
enum  {
	SUDOKU_PREFERENCES_DIALOG_0_PROPERTY,
	SUDOKU_PREFERENCES_DIALOG_NUM_PROPERTIES
};
static GParamSpec* sudoku_preferences_dialog_properties[SUDOKU_PREFERENCES_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;
typedef struct _SudokuViewPrivate SudokuViewPrivate;
typedef enum  {
	ZOOM_LEVEL_SMALL = 1,
	ZOOM_LEVEL_MEDIUM = 2,
	ZOOM_LEVEL_LARGE = 3
} ZoomLevel;

#define TYPE_ZOOM_LEVEL (zoom_level_get_type ())

#define TYPE_SUDOKU_NUMBER_PICKER (sudoku_number_picker_get_type ())
#define SUDOKU_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_NUMBER_PICKER, SudokuNumberPicker))
#define SUDOKU_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_NUMBER_PICKER, SudokuNumberPickerClass))
#define IS_SUDOKU_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_NUMBER_PICKER))
#define IS_SUDOKU_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_NUMBER_PICKER))
#define SUDOKU_NUMBER_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_NUMBER_PICKER, SudokuNumberPickerClass))

typedef struct _SudokuNumberPicker SudokuNumberPicker;
typedef struct _SudokuNumberPickerClass SudokuNumberPickerClass;

struct _SudokuPreferencesDialog {
	AdwPreferencesDialog parent_instance;
	SudokuPreferencesDialogPrivate * priv;
	AdwSwitchRow* autoclean_earmarks;
	AdwSwitchRow* show_possibilities;
	AdwSwitchRow* show_timer;
	AdwSwitchRow* number_picker_second_click;
	AdwSwitchRow* show_earmark_warnings;
	AdwSwitchRow* solution_warnings;
	AdwSwitchRow* highlight_numbers;
	AdwSwitchRow* highlight_block;
	AdwSwitchRow* highlight_row_column;
};

struct _SudokuPreferencesDialogClass {
	AdwPreferencesDialogClass parent_class;
};

struct _SudokuPreferencesDialogPrivate {
	SudokuWindow* window;
};

struct _SudokuView {
	AdwBin parent_instance;
	SudokuViewPrivate * priv;
	gboolean earmark_mode;
	gboolean autoclean_earmarks;
	gboolean number_picker_second_click;
	gboolean highlight_row_column;
	gboolean highlight_block;
	gboolean highlight_numbers;
	gdouble value_zoom_multiplier;
	ZoomLevel zoom_level;
	SudokuNumberPicker* number_picker;
};

struct _SudokuViewClass {
	AdwBinClass parent_class;
};

static gint SudokuPreferencesDialog_private_offset;
static gpointer sudoku_preferences_dialog_parent_class = NULL;

VALA_EXTERN GType sudoku_preferences_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuPreferencesDialog, g_object_unref)
VALA_EXTERN GType sudoku_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuWindow, g_object_unref)
VALA_EXTERN SudokuPreferencesDialog* sudoku_preferences_dialog_new (SudokuWindow* window);
VALA_EXTERN SudokuPreferencesDialog* sudoku_preferences_dialog_construct (GType object_type,
                                                              SudokuWindow* window);
VALA_EXTERN GSettings* sudoku_window_get_settings (SudokuWindow* self);
static void __lambda19_ (SudokuPreferencesDialog* self);
VALA_EXTERN GType sudoku_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuView, g_object_unref)
VALA_EXTERN SudokuView* sudoku_window_get_view (SudokuWindow* self);
VALA_EXTERN void sudoku_view_set_show_earmark_warnings (SudokuView* self,
                                            gboolean value);
static void ___lambda19__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda20_ (SudokuPreferencesDialog* self);
VALA_EXTERN void sudoku_view_set_show_possibilities (SudokuView* self,
                                         gboolean value);
static void ___lambda20__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda21_ (SudokuPreferencesDialog* self);
VALA_EXTERN GType zoom_level_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType sudoku_number_picker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuNumberPicker, g_object_unref)
static void ___lambda21__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda22_ (SudokuPreferencesDialog* self);
static void ___lambda22__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda23_ (SudokuPreferencesDialog* self);
VALA_EXTERN void sudoku_view_set_solution_warnings (SudokuView* self,
                                        gboolean value);
static void ___lambda23__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda24_ (SudokuPreferencesDialog* self);
VALA_EXTERN void sudoku_window_set_show_timer (SudokuWindow* self,
                                   gboolean value);
static void ___lambda24__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda25_ (SudokuPreferencesDialog* self);
static void ___lambda25__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda26_ (SudokuPreferencesDialog* self);
static void ___lambda26__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda27_ (SudokuPreferencesDialog* self);
static void ___lambda27__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void sudoku_preferences_dialog_real_dispose (GObject* base);
static void sudoku_preferences_dialog_finalize (GObject * obj);
static GType sudoku_preferences_dialog_get_type_once (void);

static inline gpointer
sudoku_preferences_dialog_get_instance_private (SudokuPreferencesDialog* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuPreferencesDialog_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
__lambda19_ (SudokuPreferencesDialog* self)
{
	gboolean value = FALSE;
	AdwSwitchRow* _tmp0_;
	SudokuWindow* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	SudokuWindow* _tmp4_;
	SudokuView* _tmp5_;
	SudokuView* _tmp6_;
	_tmp0_ = self->show_earmark_warnings;
	value = adw_switch_row_get_active (_tmp0_);
	_tmp1_ = self->priv->window;
	_tmp2_ = sudoku_window_get_settings (_tmp1_);
	_tmp3_ = _tmp2_;
	g_settings_set_boolean (_tmp3_, "show-earmark-warnings", value);
	_tmp4_ = self->priv->window;
	_tmp5_ = sudoku_window_get_view (_tmp4_);
	_tmp6_ = _tmp5_;
	if (_tmp6_ != NULL) {
		SudokuWindow* _tmp7_;
		SudokuView* _tmp8_;
		SudokuView* _tmp9_;
		_tmp7_ = self->priv->window;
		_tmp8_ = sudoku_window_get_view (_tmp7_);
		_tmp9_ = _tmp8_;
		sudoku_view_set_show_earmark_warnings (_tmp9_, value);
	}
}

static void
___lambda19__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda19_ ((SudokuPreferencesDialog*) self);
}

static void
__lambda20_ (SudokuPreferencesDialog* self)
{
	gboolean value = FALSE;
	AdwSwitchRow* _tmp0_;
	SudokuWindow* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	SudokuWindow* _tmp4_;
	SudokuView* _tmp5_;
	SudokuView* _tmp6_;
	_tmp0_ = self->show_possibilities;
	value = adw_switch_row_get_active (_tmp0_);
	_tmp1_ = self->priv->window;
	_tmp2_ = sudoku_window_get_settings (_tmp1_);
	_tmp3_ = _tmp2_;
	g_settings_set_boolean (_tmp3_, "show-possibilities", value);
	_tmp4_ = self->priv->window;
	_tmp5_ = sudoku_window_get_view (_tmp4_);
	_tmp6_ = _tmp5_;
	if (_tmp6_ != NULL) {
		SudokuWindow* _tmp7_;
		SudokuView* _tmp8_;
		SudokuView* _tmp9_;
		_tmp7_ = self->priv->window;
		_tmp8_ = sudoku_window_get_view (_tmp7_);
		_tmp9_ = _tmp8_;
		sudoku_view_set_show_possibilities (_tmp9_, value);
	}
}

static void
___lambda20__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda20_ ((SudokuPreferencesDialog*) self);
}

static void
__lambda21_ (SudokuPreferencesDialog* self)
{
	gboolean value = FALSE;
	AdwSwitchRow* _tmp0_;
	SudokuWindow* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	SudokuWindow* _tmp4_;
	SudokuView* _tmp5_;
	SudokuView* _tmp6_;
	_tmp0_ = self->autoclean_earmarks;
	value = adw_switch_row_get_active (_tmp0_);
	_tmp1_ = self->priv->window;
	_tmp2_ = sudoku_window_get_settings (_tmp1_);
	_tmp3_ = _tmp2_;
	g_settings_set_boolean (_tmp3_, "autoclean-earmarks", value);
	_tmp4_ = self->priv->window;
	_tmp5_ = sudoku_window_get_view (_tmp4_);
	_tmp6_ = _tmp5_;
	if (_tmp6_ != NULL) {
		SudokuWindow* _tmp7_;
		SudokuView* _tmp8_;
		SudokuView* _tmp9_;
		_tmp7_ = self->priv->window;
		_tmp8_ = sudoku_window_get_view (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp9_->autoclean_earmarks = value;
	}
}

static void
___lambda21__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda21_ ((SudokuPreferencesDialog*) self);
}

static void
__lambda22_ (SudokuPreferencesDialog* self)
{
	gboolean value = FALSE;
	AdwSwitchRow* _tmp0_;
	SudokuWindow* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	SudokuWindow* _tmp4_;
	SudokuView* _tmp5_;
	SudokuView* _tmp6_;
	_tmp0_ = self->number_picker_second_click;
	value = adw_switch_row_get_active (_tmp0_);
	_tmp1_ = self->priv->window;
	_tmp2_ = sudoku_window_get_settings (_tmp1_);
	_tmp3_ = _tmp2_;
	g_settings_set_boolean (_tmp3_, "number-picker-second-click", value);
	_tmp4_ = self->priv->window;
	_tmp5_ = sudoku_window_get_view (_tmp4_);
	_tmp6_ = _tmp5_;
	if (_tmp6_ != NULL) {
		SudokuWindow* _tmp7_;
		SudokuView* _tmp8_;
		SudokuView* _tmp9_;
		_tmp7_ = self->priv->window;
		_tmp8_ = sudoku_window_get_view (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp9_->number_picker_second_click = value;
	}
}

static void
___lambda22__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda22_ ((SudokuPreferencesDialog*) self);
}

static void
__lambda23_ (SudokuPreferencesDialog* self)
{
	gboolean value = FALSE;
	AdwSwitchRow* _tmp0_;
	SudokuWindow* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	SudokuWindow* _tmp4_;
	SudokuView* _tmp5_;
	SudokuView* _tmp6_;
	_tmp0_ = self->solution_warnings;
	value = adw_switch_row_get_active (_tmp0_);
	_tmp1_ = self->priv->window;
	_tmp2_ = sudoku_window_get_settings (_tmp1_);
	_tmp3_ = _tmp2_;
	g_settings_set_boolean (_tmp3_, "solution-warnings", value);
	_tmp4_ = self->priv->window;
	_tmp5_ = sudoku_window_get_view (_tmp4_);
	_tmp6_ = _tmp5_;
	if (_tmp6_ != NULL) {
		SudokuWindow* _tmp7_;
		SudokuView* _tmp8_;
		SudokuView* _tmp9_;
		_tmp7_ = self->priv->window;
		_tmp8_ = sudoku_window_get_view (_tmp7_);
		_tmp9_ = _tmp8_;
		sudoku_view_set_solution_warnings (_tmp9_, value);
	}
}

static void
___lambda23__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda23_ ((SudokuPreferencesDialog*) self);
}

static void
__lambda24_ (SudokuPreferencesDialog* self)
{
	gboolean value = FALSE;
	AdwSwitchRow* _tmp0_;
	SudokuWindow* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	SudokuWindow* _tmp4_;
	_tmp0_ = self->show_timer;
	value = adw_switch_row_get_active (_tmp0_);
	_tmp1_ = self->priv->window;
	_tmp2_ = sudoku_window_get_settings (_tmp1_);
	_tmp3_ = _tmp2_;
	g_settings_set_boolean (_tmp3_, "show-timer", value);
	_tmp4_ = self->priv->window;
	sudoku_window_set_show_timer (_tmp4_, value);
}

static void
___lambda24__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda24_ ((SudokuPreferencesDialog*) self);
}

static void
__lambda25_ (SudokuPreferencesDialog* self)
{
	gboolean value = FALSE;
	AdwSwitchRow* _tmp0_;
	SudokuWindow* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	SudokuWindow* _tmp4_;
	SudokuView* _tmp5_;
	SudokuView* _tmp6_;
	_tmp0_ = self->highlight_row_column;
	value = adw_switch_row_get_active (_tmp0_);
	_tmp1_ = self->priv->window;
	_tmp2_ = sudoku_window_get_settings (_tmp1_);
	_tmp3_ = _tmp2_;
	g_settings_set_boolean (_tmp3_, "highlight-row-column", value);
	_tmp4_ = self->priv->window;
	_tmp5_ = sudoku_window_get_view (_tmp4_);
	_tmp6_ = _tmp5_;
	if (_tmp6_ != NULL) {
		SudokuWindow* _tmp7_;
		SudokuView* _tmp8_;
		SudokuView* _tmp9_;
		_tmp7_ = self->priv->window;
		_tmp8_ = sudoku_window_get_view (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp9_->highlight_row_column = value;
	}
}

static void
___lambda25__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda25_ ((SudokuPreferencesDialog*) self);
}

static void
__lambda26_ (SudokuPreferencesDialog* self)
{
	gboolean value = FALSE;
	AdwSwitchRow* _tmp0_;
	SudokuWindow* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	SudokuWindow* _tmp4_;
	SudokuView* _tmp5_;
	SudokuView* _tmp6_;
	_tmp0_ = self->highlight_block;
	value = adw_switch_row_get_active (_tmp0_);
	_tmp1_ = self->priv->window;
	_tmp2_ = sudoku_window_get_settings (_tmp1_);
	_tmp3_ = _tmp2_;
	g_settings_set_boolean (_tmp3_, "highlight-block", value);
	_tmp4_ = self->priv->window;
	_tmp5_ = sudoku_window_get_view (_tmp4_);
	_tmp6_ = _tmp5_;
	if (_tmp6_ != NULL) {
		SudokuWindow* _tmp7_;
		SudokuView* _tmp8_;
		SudokuView* _tmp9_;
		_tmp7_ = self->priv->window;
		_tmp8_ = sudoku_window_get_view (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp9_->highlight_block = value;
	}
}

static void
___lambda26__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda26_ ((SudokuPreferencesDialog*) self);
}

static void
__lambda27_ (SudokuPreferencesDialog* self)
{
	gboolean value = FALSE;
	AdwSwitchRow* _tmp0_;
	SudokuWindow* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	SudokuWindow* _tmp4_;
	SudokuView* _tmp5_;
	SudokuView* _tmp6_;
	_tmp0_ = self->highlight_numbers;
	value = adw_switch_row_get_active (_tmp0_);
	_tmp1_ = self->priv->window;
	_tmp2_ = sudoku_window_get_settings (_tmp1_);
	_tmp3_ = _tmp2_;
	g_settings_set_boolean (_tmp3_, "highlight-numbers", value);
	_tmp4_ = self->priv->window;
	_tmp5_ = sudoku_window_get_view (_tmp4_);
	_tmp6_ = _tmp5_;
	if (_tmp6_ != NULL) {
		SudokuWindow* _tmp7_;
		SudokuView* _tmp8_;
		SudokuView* _tmp9_;
		_tmp7_ = self->priv->window;
		_tmp8_ = sudoku_window_get_view (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp9_->highlight_numbers = value;
	}
}

static void
___lambda27__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda27_ ((SudokuPreferencesDialog*) self);
}

SudokuPreferencesDialog*
sudoku_preferences_dialog_construct (GType object_type,
                                     SudokuWindow* window)
{
	SudokuPreferencesDialog * self = NULL;
	SudokuWindow* _tmp0_;
	AdwSwitchRow* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	AdwSwitchRow* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	AdwSwitchRow* _tmp7_;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
	AdwSwitchRow* _tmp10_;
	GSettings* _tmp11_;
	GSettings* _tmp12_;
	AdwSwitchRow* _tmp13_;
	GSettings* _tmp14_;
	GSettings* _tmp15_;
	AdwSwitchRow* _tmp16_;
	GSettings* _tmp17_;
	GSettings* _tmp18_;
	AdwSwitchRow* _tmp19_;
	GSettings* _tmp20_;
	GSettings* _tmp21_;
	AdwSwitchRow* _tmp22_;
	GSettings* _tmp23_;
	GSettings* _tmp24_;
	AdwSwitchRow* _tmp25_;
	GSettings* _tmp26_;
	GSettings* _tmp27_;
	AdwSwitchRow* _tmp28_;
	AdwSwitchRow* _tmp29_;
	AdwSwitchRow* _tmp30_;
	AdwSwitchRow* _tmp31_;
	AdwSwitchRow* _tmp32_;
	AdwSwitchRow* _tmp33_;
	AdwSwitchRow* _tmp34_;
	AdwSwitchRow* _tmp35_;
	AdwSwitchRow* _tmp36_;
	g_return_val_if_fail (window != NULL, NULL);
	self = (SudokuPreferencesDialog*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (window);
	_g_object_unref0 (self->priv->window);
	self->priv->window = _tmp0_;
	_tmp1_ = self->show_timer;
	_tmp2_ = sudoku_window_get_settings (window);
	_tmp3_ = _tmp2_;
	adw_switch_row_set_active (_tmp1_, g_settings_get_boolean (_tmp3_, "show-timer"));
	_tmp4_ = self->show_earmark_warnings;
	_tmp5_ = sudoku_window_get_settings (window);
	_tmp6_ = _tmp5_;
	adw_switch_row_set_active (_tmp4_, g_settings_get_boolean (_tmp6_, "show-earmark-warnings"));
	_tmp7_ = self->show_possibilities;
	_tmp8_ = sudoku_window_get_settings (window);
	_tmp9_ = _tmp8_;
	adw_switch_row_set_active (_tmp7_, g_settings_get_boolean (_tmp9_, "show-possibilities"));
	_tmp10_ = self->number_picker_second_click;
	_tmp11_ = sudoku_window_get_settings (window);
	_tmp12_ = _tmp11_;
	adw_switch_row_set_active (_tmp10_, g_settings_get_boolean (_tmp12_, "number-picker-second-click"));
	_tmp13_ = self->solution_warnings;
	_tmp14_ = sudoku_window_get_settings (window);
	_tmp15_ = _tmp14_;
	adw_switch_row_set_active (_tmp13_, g_settings_get_boolean (_tmp15_, "solution-warnings"));
	_tmp16_ = self->autoclean_earmarks;
	_tmp17_ = sudoku_window_get_settings (window);
	_tmp18_ = _tmp17_;
	adw_switch_row_set_active (_tmp16_, g_settings_get_boolean (_tmp18_, "autoclean-earmarks"));
	_tmp19_ = self->highlight_row_column;
	_tmp20_ = sudoku_window_get_settings (window);
	_tmp21_ = _tmp20_;
	adw_switch_row_set_active (_tmp19_, g_settings_get_boolean (_tmp21_, "highlight-row-column"));
	_tmp22_ = self->highlight_block;
	_tmp23_ = sudoku_window_get_settings (window);
	_tmp24_ = _tmp23_;
	adw_switch_row_set_active (_tmp22_, g_settings_get_boolean (_tmp24_, "highlight-block"));
	_tmp25_ = self->highlight_numbers;
	_tmp26_ = sudoku_window_get_settings (window);
	_tmp27_ = _tmp26_;
	adw_switch_row_set_active (_tmp25_, g_settings_get_boolean (_tmp27_, "highlight-numbers"));
	_tmp28_ = self->show_earmark_warnings;
	g_signal_connect_object ((GObject*) _tmp28_, "notify::active", (GCallback) ___lambda19__g_object_notify, self, 0);
	_tmp29_ = self->show_possibilities;
	g_signal_connect_object ((GObject*) _tmp29_, "notify::active", (GCallback) ___lambda20__g_object_notify, self, 0);
	_tmp30_ = self->autoclean_earmarks;
	g_signal_connect_object ((GObject*) _tmp30_, "notify::active", (GCallback) ___lambda21__g_object_notify, self, 0);
	_tmp31_ = self->number_picker_second_click;
	g_signal_connect_object ((GObject*) _tmp31_, "notify::active", (GCallback) ___lambda22__g_object_notify, self, 0);
	_tmp32_ = self->solution_warnings;
	g_signal_connect_object ((GObject*) _tmp32_, "notify::active", (GCallback) ___lambda23__g_object_notify, self, 0);
	_tmp33_ = self->show_timer;
	g_signal_connect_object ((GObject*) _tmp33_, "notify::active", (GCallback) ___lambda24__g_object_notify, self, 0);
	_tmp34_ = self->highlight_row_column;
	g_signal_connect_object ((GObject*) _tmp34_, "notify::active", (GCallback) ___lambda25__g_object_notify, self, 0);
	_tmp35_ = self->highlight_block;
	g_signal_connect_object ((GObject*) _tmp35_, "notify::active", (GCallback) ___lambda26__g_object_notify, self, 0);
	_tmp36_ = self->highlight_numbers;
	g_signal_connect_object ((GObject*) _tmp36_, "notify::active", (GCallback) ___lambda27__g_object_notify, self, 0);
	return self;
}

SudokuPreferencesDialog*
sudoku_preferences_dialog_new (SudokuWindow* window)
{
	return sudoku_preferences_dialog_construct (TYPE_SUDOKU_PREFERENCES_DIALOG, window);
}

static void
sudoku_preferences_dialog_real_dispose (GObject* base)
{
	SudokuPreferencesDialog * self;
	self = (SudokuPreferencesDialog*) base;
	gtk_widget_dispose_template ((GtkWidget*) self, G_TYPE_FROM_INSTANCE ((GObject*) self));
	G_OBJECT_CLASS (sudoku_preferences_dialog_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_preferences_dialog_get_type (), AdwPreferencesDialog));
}

static void
sudoku_preferences_dialog_class_init (SudokuPreferencesDialogClass * klass,
                                      gpointer klass_data)
{
	sudoku_preferences_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SudokuPreferencesDialog_private_offset);
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) sudoku_preferences_dialog_real_dispose;
	G_OBJECT_CLASS (klass)->finalize = sudoku_preferences_dialog_finalize;
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Sudoku/ui/preferences-dialog.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "autoclean_earmarks", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, autoclean_earmarks));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "show_possibilities", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, show_possibilities));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "show_timer", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, show_timer));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "number_picker_second_click", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, number_picker_second_click));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "show_earmark_warnings", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, show_earmark_warnings));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "solution_warnings", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, solution_warnings));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "highlight_numbers", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, highlight_numbers));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "highlight_block", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, highlight_block));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "highlight_row_column", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, highlight_row_column));
}

static void
sudoku_preferences_dialog_instance_init (SudokuPreferencesDialog * self,
                                         gpointer klass)
{
	self->priv = sudoku_preferences_dialog_get_instance_private (self);
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
sudoku_preferences_dialog_finalize (GObject * obj)
{
	SudokuPreferencesDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_PREFERENCES_DIALOG, SudokuPreferencesDialog);
	_g_object_unref0 (self->priv->window);
	G_OBJECT_CLASS (sudoku_preferences_dialog_parent_class)->finalize (obj);
}

static GType
sudoku_preferences_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuPreferencesDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_preferences_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuPreferencesDialog), 0, (GInstanceInitFunc) sudoku_preferences_dialog_instance_init, NULL };
	GType sudoku_preferences_dialog_type_id;
	sudoku_preferences_dialog_type_id = g_type_register_static (adw_preferences_dialog_get_type (), "SudokuPreferencesDialog", &g_define_type_info, 0);
	SudokuPreferencesDialog_private_offset = g_type_add_instance_private (sudoku_preferences_dialog_type_id, sizeof (SudokuPreferencesDialogPrivate));
	return sudoku_preferences_dialog_type_id;
}

GType
sudoku_preferences_dialog_get_type (void)
{
	static volatile gsize sudoku_preferences_dialog_type_id__once = 0;
	if (g_once_init_enter (&sudoku_preferences_dialog_type_id__once)) {
		GType sudoku_preferences_dialog_type_id;
		sudoku_preferences_dialog_type_id = sudoku_preferences_dialog_get_type_once ();
		g_once_init_leave (&sudoku_preferences_dialog_type_id__once, sudoku_preferences_dialog_type_id);
	}
	return sudoku_preferences_dialog_type_id__once;
}

